<template>
  <section>
    <h2 class="gl-text-size-h2">Defined rules as of {{ date }}</h2>

    <gl-loading-icon v-if="pending" size="xl" />

    <scan-failed-to-load-alert v-else-if="errors.length > 0" :errors="errors" />

    <gl-tabs v-else content-class="gl-pt-0" sync-active-tab-with-query-params>
      <gl-tab title="By rule ID" query-param-value="by-id">
        <gl-table-lite v-bind="allRulesTableDataProps">
          <template #cell(id)="{ item }">{{ shortId(item.id) }}</template>
        </gl-table-lite>
      </gl-tab>
      <gl-tab title="By group" query-param-value="by-group">
        <section class="gl-mb-5">
          <h3 class="gl-my-6">Key</h3>
          <dl class="definitions-grid gl-display-grid gl-gap-2 gl-column-gap-6">
            <dt>Non-compliant rules</dt>
            <dd>All rules of severity ERROR and WARNING.</dd>

            <dt>Non-compliant findings</dt>
            <dd>
              All findings of severity ERROR: a missing accessibility check in a single spec file or
              a spec suite.
            </dd>

            <dt>Findings with exceptions</dt>
            <dd>
              All findings of severity WARNING: a spec file with accessibility check that skips
              certain violations.
            </dd>

            <dt>Compliant rules</dt>
            <dd>All rules of severity INFO.</dd>

            <dt>Compliant findings</dt>
            <dd>All findings of severity INFO.</dd>

            <dt>Total findings</dt>
            <dd>A sum of all findings: non-compliant, with exceptions and compliant.</dd>

            <dt>Compliance percentage</dt>
            <dd>Percentage based on compliant findings divided by total findings.</dd>
          </dl>
        </section>
        <gl-table-lite v-bind="groupRulesTableDataProps">
          <template #cell(groupLabel)="{ item }">
            <gl-label :title="item.group" scoped background-color="#A8D695" />
          </template>
        </gl-table-lite>
      </gl-tab>
    </gl-tabs>
  </section>
</template>

<script>
import GlLoadingIcon from '@gitlab/ui/src/components/base/loading_icon/loading_icon.vue';
import GlTab from '@gitlab/ui/src/components/base/tabs/tab/tab.vue';
import GlTabs from '@gitlab/ui/src/components/base/tabs/tabs/tabs.vue';
import GlTableLite from '@gitlab/ui/src/components/base/table/table.vue';
import GlLabel from '@gitlab/ui/src/components/base/label/label.vue';
import { shortId } from 'shared/rules.js';
import ScanFailedToLoadAlert from '~/components/scan_failed_to_load_alert.vue';
import { getCurrentScan, getRules, getScansSummary } from '~/lib/api';
import { allRulesTableDataProps, groupRulesTableDataProps } from '~/lib/rules_table';

export default {
  name: 'RulesPage',
  components: {
    GlLoadingIcon,
    GlTab,
    GlTabs,
    GlTableLite,
    GlLabel,
    ScanFailedToLoadAlert,
  },
  layout: 'body_scroll',
  data() {
    return {
      scan: null,
      rules: null,
      date: '...',
    };
  },
  async fetch() {
    const [scans, scan, rules] = await Promise.all([
      getScansSummary(),
      getCurrentScan(),
      getRules(),
    ]);

    this.date = scans.current.date;
    this.scan = scan;
    this.rules = rules;
  },
  fetchOnServer: false,
  computed: {
    pending() {
      return this.$fetchState?.pending;
    },
    errors() {
      const { error } = this.$fetchState;
      return error ? [error] : [];
    },
    allRulesTableDataProps() {
      return allRulesTableDataProps(this.scan, this.rules);
    },
    groupRulesTableDataProps() {
      return groupRulesTableDataProps(this.scan, this.rules);
    },
  },
  methods: {
    shortId,
  },
};
</script>

<style>
.definitions-grid {
  grid-template-columns: auto 1fr;
}
</style>
